DICOD(8)

NAME
dicod - GNU dictionary server

SYNOPSIS
dicod [-ETVfist] [-D SYMBOL[=VALUE]] [-I DIR] [-L DIR] [-x LEVEL-SPEC] [--config=FILE] [--config-help] [--debug=LEVEL-SPEC] [--define=SYMBOL[=VALUE]] [--foreground] [--include-dir=DIR] [--inetd] [--lib-dir=DIR] [--lint] [--no-preprocessor] [--no-transcript] [--preprocessor=PROG] [--single-process] [--source-info] [--stderr] [--syslog] [--trace-grammar] [--trace-lex] [--transcript]

dicod [OPTIONS] -r|--runtest MODULE [ARG...] [-- ARG...]

dicod -h

dicod --help

dicod --usage

dicod --version

NOTE
This manpage is a short description of GNU dicod. For a detailed discussion, including examples and usage recommendations, refer to the GNU Dico Manual available in texinfo format. If the info reader and GNU Dico documentation are properly installed on your system, the command

    info dico

should give you access to the complete manual.

You can also view the manual using the info mode in emacs(1), or find it in various formats online at

    http://www.gnu.org.ua/software/dico/manual

If any discrepancies occur between this manpage and the GNU Dico Manual, the later shall be considered the authoritative source.

DESCRIPTION
Dicod is a dictionary server daemon. It implements the DICT protocol defined in RFC 2229.

Dicod is a part of GNU Dico, a package that provides, apart from the server itself, a set of loadable modules and a command line client program dico(1).

Upon startup, the server reads its configuration file /usr/local/etc/dicod.conf, loads and initializes the dictionary modules defined there and starts serving requests.

When started in daemon mode (which is the default), dicod listens for incoming connections on sockets requested in its configuration. When an incoming connection arrives, the server spawns a copy of itself dedicated for serving that particular connection. Unless configured otherwise, in this mode dicod detaches itself from the controlling terminal and operates in background.

In inetd mode the server listens on DICT requests on its standard input stream and sends replies to its standard output stream. As the name indicates, this mode is intended for use with inetd(8) or a similar daemon.

OPTIONS

  Program Mode

-E  Preprocess configuration file and exit. See the section PREPROCESSOR below.

-i, --inetd
    Run in inetd mode.

-t, --lint
    Check configuration file syntax and exit.

-r, --runtest
    Run unit tests for module. The arguments that follow this option are collected into two arrays: arguments up to the -- marker (or end of line, if it is not present) form the vector that is passed to the module's dico_run_test function. If the -- marker is present, arguments that follow it are collected into a separate argument vector starting from slot 1, its 0th element is set to point to the module name and the resulting vector is passed to the dico_init function of the module. When running unit tests, configuration file is ignored. The diagnostic messages are printed to the standard error output.

  Modifiers

--config=FILE
    Read configuration from FILE, instead of /usr/local/etc/dicod.conf.

-f, --foreground
    Operate in foreground.

-s, --single-process
    In daemon mode, process connections in the main process, without starting subprocesses for each connection. This means that the daemon is able to serve only one client at a time. This option is intended for debugging purposes only. Never use it in production environment.

--stderr
    Output diagnostic to stderr. Useful only together with --foreground.

--syslog
    After successful startup, output any diagnostic to syslog. This is the default.

  Debugging

-T, --transcript
    Enable session transcripts. This instructs dicod to log all commands it receives and all responses it sends during the session. Transcript is logged via the default logging channel. If syslog is enabled, the debug priority is used.

--no-transcript
    Disable session transcript.

--source-info
    Include source line information in the debugging output.

--trace-grammar
    Trace configuration file parser.

--trace-lex
    Trace configuration file lexer.

-x, --debug=NUMBER
    Set debug verbosity level. The argument is an integer ranging from 0 (no debugging, default) to 100 (maximum debugging information).

  Preprocessor Control

-D, --define=SYMBOL[=VALUE]
    Define preprocessor symbol SYMBOL. Optional VALUE supplies the new symbol value. This option is passed to the preprocessor verbatim.

-I, --include-dir=DIR
    Add the directory DIR to the list of directories to be searched for preprocessor include files.

--no-preprocessor
    Do not use external preprocessor.

--preprocessor=PROG
    Use PROG as a preprocessor for configuration file.

  Additional information options

--config-help
    Show a summary of configuration file syntax and available statements.

-V, --version
    Print program version.

-h, --help
    Print a short summary of command line options.

--usage
    Display a short usage message.

PREPROCESSOR
Prior to parsing, dicod configuration file is preprocessed using m4(1). It is invoked with `-s' flag, instructing it to include line synchronization information in its output. This information is then used by the parser to display meaningful diagnostic.

The include path is set initially to the following two directories:

/usr/local/share/dico/2.6.95/include
/usr/local/share/dico/include

It can be further modified using the -I (--include-directory) command line option.

If the file pp-setup is found in the include path, it is sourced before the configuration file. This can be used to provide macros and constants for the configuration.

The default pp-setup file renames all m4 built-in macros so they start with the prefix m4_. This is similar to GNU m4 --prefix-builtin option, but has an advantage that it works with other m4 implementations as well.

Additional definitions can also be provided from the command line using the -D (--define) option.

To view preprocessed configuration, use the -E option. It prints the preprocessed text on the standard output.

To disable preprocessing, use the --no-preprocessor option.

SEE ALSO
dicod.conf(5), dico(1), RFC 2229.

Complete GNU Dico manual: run info dico or use emacs(1) info mode to read it.

Online copies of GNU Dico documentation in various formats can be found at:

http://www.gnu.org.ua/software/dico/manual

AUTHORS
Sergey Poznyakoff

BUG REPORTS
Report bugs to <bug-dico@gnu.org.ua>.

COPYRIGHT
Copyright © 2008-2018 Sergey Poznyakoff
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.